import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class PintofWords_Navigation extends PApplet {

Button button[];
Library library[];
Pub Pub[];

int viewHomepage = 0;
int viewLibrary = 1;
int viewRead = 2;
int viewReadings = 3;
int viewMap = 4;
int viewInvite = 5;
int viewExit = 6;
int viewLibraryIN = 7;
int viewBook = 8;
int viewEvent =9;
int pizzinoYEP = 0;

int screenMode = viewHomepage;


public void setup() {
  size(480, 320);
  smooth();

  loadImages();
  createButton();
  createLibrary();
  createPub();

  bx= 100; //defining the initial position for the napkin (menuInvite)
  by = 100;

  numberOfLetters = 8;
}


public void draw() {
  //  color c = get(mouseX , mouseY);
  //  println ("color=" + c);

  background(0);

  updateBackground();
  if (screenMode== viewHomepage) {
    drawHomepage();
  }

  else if (screenMode== viewLibrary) {
    drawLibrary();
  }

  else if (screenMode == viewLibraryIN) {
drawLibraryIN();
  }

  else if (screenMode == viewBook) {
drawBook();
  }

  else if (screenMode == viewRead) {
    drawRead();
  }

  else if (screenMode == viewReadings) {
    drawReadings();
  }

  else if (screenMode == viewMap) {
     drawMap();
  }

  else if (screenMode == viewEvent) {
    drawEvent();
  }

  else if (screenMode == viewInvite) {
    drawInvite();
  }

  else if (screenMode == viewExit) {
    drawExit();
  }  
}


public void mousePressed() {
  mousePressedBackground(); 
 
  if (screenMode == viewHomepage) {
    int c = buttons.get(PApplet.parseInt (mouseX-x_position), PApplet.parseInt (mouseY-y_position));
   

    if (c== -39936) {
      screenMode = viewReadings;
    }
    if (c== -59904) {
      screenMode = viewMap;
    }
    if(c ==-16746241 ) {
      screenMode = viewLibrary;
    }

    if(c == -16766721) {
      screenMode = viewRead;
    } 

    if (c== -65326) {
      screenMode = viewInvite;
    }
    if (c== -16711776) {
      screenMode = viewExit;
    }
  }

  else if(screenMode == viewInvite) {
    if(bover) { 
      locked = true;
    } 
    else {
      locked = false;
    }
    bdifx = mouseX-bx; 
    bdify = mouseY-by;
  }

  else if (screenMode == viewReadings) {
    if (counter <= (numberOfLetters+1)) {
      counter+=1;
    }
  }
  
   println ("screenMode = " + screenMode);
}


public void mouseDragged() {
  if(locked) {
    bx = mouseX-bdifx; 
    by = mouseY-bdify;
  }
}


public void mouseReleased() {
  locked = false;
}

//////////////////////////Background
PImage home;
PImage buttons;

/////////////AllMenu
PImage back;
PImage menuLibrary;
PImage menuReadBackground;
PImage menuRead;
PImage menuReadings;
PImage menuMap;
PImage menuInvite;

//////////////////////////LibraryIN
PImage libraryIN;
PImage titleBookOff;
PImage upload;
//////////////////////////ReadBook
PImage backVERT;
PImage bookFantasy;
//////////////////////////Pub
PImage Pub_event;
PImage Pub_SharkOn;
//////////////////////////Readings
PImage keyboard;
PImage Add;
//////////////////////////Invite
PImage pizzino;



public void loadImages(){

  buttons = loadImage ("buttons.png");
  home = loadImage ("homepage.jpg");
  menuLibrary = loadImage ("menuLibrary.png");
  menuRead = loadImage ("readOn.png");
  menuReadBackground = loadImage ("readBackground.jpg");
  menuReadings = loadImage ("readings.png");
  menuMap = loadImage ("map.png");
  menuInvite = loadImage ("invite.png");

  back = loadImage ("backButton.png");

//////////////////////////////////////////////////////////LibraryIN
  libraryIN = loadImage ("libraryIN.png");
  titleBookOff = loadImage ("titleBookOff.png");
  upload = loadImage ("upload.png");
//////////////////////////////////////////////////////////ReadBook
  backVERT = loadImage ("backButtonVERT.png");
  bookFantasy = loadImage ("bookLibrary.png");
//////////////////////////////////////////////////////////PubEvent
Pub_event = loadImage ("events.png");
Pub_SharkOn = loadImage ("SharkPubon.png");
//////////////////////////////////////////////////////////Readings
keyboard = loadImage ("keyboard.png");
  Add = loadImage ("add.png");
//////////////////////////////////////////////////////////Invite
  pizzino = loadImage ("toil.png");
}




public void drawRead(){
  image (menuReadBackground,x_position,y_position);
  image (menuRead,0,0);
  image  (back, 0, 0);
  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311){
    screenMode = viewHomepage;
  }
  //fill (112,203,79, 50);
  //rect (50,40, 100,50);
  if (mousePressed && mouseX>45 && mouseX<145 && mouseY>40 & mouseY<90){
    background(255);
  }
}

class Button{
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5f;


  Button(int level, float x, float y){
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("button" + level) + ".png");
    //println(("button" + level)  + ".png");
  }

  public void paint(){
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  public void move(float x, float y){
    this.xTarget = x;
    this.yTarget = y;
  }
}


public void createButton(){
  button = new Button[6];
  button[0] = new Button(1,  150, 75); 
  button[1] = new Button(2,  560, 80); 
  button[2] = new Button(3,  600, 270);
  button[3] = new Button(4,  385, 268);
  button[4] = new Button(5,  183, 370);
  button[5] = new Button(6,  490, 375);
}

//////////////////////////////////////////LibraryBUTTONS
class Library{
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5f;


  Library(int level, float x, float y){
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("library" + level) + ".png");
   // println(("library" + level)  + ".png");
  }

  public void paint(){
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  public void move(float x, float y){
    this.xTarget = x;
    this.yTarget = y;
  }
}


public void createLibrary(){
  library = new Library[6];
  library[0] = new Library(1,  380,100); 
  library[1] = new Library(2,  130, 350); 
  library[2] = new Library(3,  100, 130);
  library[3] = new Library(4,  560, 370);
  library[4] = new Library(5,  298,315);
  library[5] = new Library(6,  578,190);
}

//////////////////////////////////////////PUB_buttons
class Pub{
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5f;


  Pub(int level, float x, float y){
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("Pub" + level) + ".png");
   // println(("Pub" + level)  + ".png");
  }

  public void paint(){
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  public void move(float x, float y){
    this.xTarget = x;
    this.yTarget = y;
  }
}


public void createPub(){
  Pub = new Pub[4];
  Pub[0] = new Pub(1,  222,285); 
  Pub[1] = new Pub(2,  450,115); 
  Pub[2] = new Pub(3,  413,190);
  Pub[3] = new Pub(4,  245,128);
}

public float progress(float start, float end, float percent) {
  return start + ((end - start) * percent);
}

////////////////////////// Position & Animation Variables

float friction = 0.95f;

float x_velocity = - 1;
float x_position = -180;
float x_offset = - 1;
float x_refresh = -180;

float y_velocity = - 1;
float y_position = -30;
float y_offset = - 1;
float y_refresh = -30;

float percentage = 0;

///////////////////////////////INVITE variables
float bx;
float by;
int bh = 301;
int bl = 290;
boolean bover = false;
boolean locked = false;
float bdifx = 0.0f; 
float bdify = 0.0f; 

boolean moveCheck = false;


/////////////////////////////
int counter=0;
//the number of letters you have to type is the number of times you have to touch the screen
int numberOfLetters;


///////////////////////////////////////menuBACKGROUND
public void updateBackground() {

  if(mousePressed) { 
    x_velocity = (mouseX + x_offset) - x_position;
    x_position = mouseX + x_offset;
    y_velocity = (mouseY + y_offset) - y_position;
    y_position = mouseY + y_offset;
  }
  else {
    x_velocity = x_velocity * friction;
    x_position = x_position + x_velocity;
    y_velocity = y_velocity * friction;
    y_position = y_position + y_velocity;
  } 
  /////////////////////////////////stoppig edges////////////////////////
  if (x_position > 0) {
    x_position = 0;
  }
  if (x_position < (- 420)) {
    x_position = - 420;
  }
  if (y_position > 0) {
    y_position = 0;
  }
  if (y_position < (- 360)) {
    y_position = - 360;
  }
}



public void movetocenter() {
  //if(x_position != -480 || y_position != -640) {

  if(PApplet.parseInt(x_position) < -175 && PApplet.parseInt(x_position) > -185 && PApplet.parseInt(y_position) < -25 && PApplet.parseInt(y_position) > -35){
    moveCheck = false;
  }

  if(x_position != -1200 || y_position != -1400) {
    x_velocity = (x_refresh - x_position) * 0.054f;
    y_velocity = (y_refresh - y_position) * 0.054f;
  }

}


public void mousePressedBackground() {
  if((mouseX > x_position - 1600)&&(mouseX <  x_position + 1600)) {
    x_offset = x_position - mouseX;
  }
  if (mouseY > (y_position - 1440) && mouseY <  (y_position + 1440)) {
    y_offset = y_position - mouseY;
  }
}


/////////////////////////////////menuHOMEPAGE
public void drawHomepage() {

  if(moveCheck){
    movetocenter();
  }

  image (buttons, x_position, y_position);
  image (home, x_position, y_position);

  for (int i = 0; i<button.length; i++) {
    button[i].paint();
  }
}

//////////////////////////////////////////menuLIBRARY
public void drawLibrary() {
  image (menuLibrary,x_position, y_position);
  for (int i = 0; i<library.length; i++) {
    library[i].paint();
  }

  image (back, 0, 0);


  if (mousePressed && mouseX>430 && mouseX< 470 && mouseY>y_position  + 260 && mouseY< +311) {
    println ("Y");
    moveCheck = true;

    screenMode = viewHomepage;
  }

  if (mousePressed && mouseX>(x_position +545) && mouseX<(x_position+890) && mouseY>(y_position +140) && mouseY<(y_position+311)) {
    screenMode = viewLibraryIN;
  }
}


public void drawLibraryIN() {
  background (0);
  image (libraryIN,0,0);
  image (titleBookOff, 29,8);
  image (upload,361, 22);
  image (back, 0, 0);
  // fill (203,85,21, 52);
  // rect (38.5,41, 96,55);
  // image (titleBookOn,80,60);
  if (mousePressed && mouseX>38.5f && mouseX<134.5f && mouseY>41 & mouseY<96) {
    screenMode = viewBook;
  }
  if (mousePressed && mouseX>430  && mouseX<470 && mouseY>260 & mouseY<311) {
    screenMode = viewLibrary;
  }
}

///////////////////////////////////////////////drawBOOK
public void drawBook() {
  background (0);
  image (bookFantasy,0,0);
  image (backVERT, 154,3);
  //fill (30,45,100, 30);
  //rect (420,9, 47,31);
  if (mousePressed && mouseX>420 && mouseX<467 && mouseY>9 & mouseY<45) {
    screenMode = viewLibraryIN;
  }
}

//////////////////////////////////////////////////////menuMAP
public void drawMap() {
  image (menuMap,x_position, y_position);
  image (back, 0,0);
  for (int i = 0; i<Pub.length; i++) {
    Pub[i].paint();
  }
  // fill (30,45,100, 30);
  //rect (480,275, 35,63);

  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311) { //////////selection BackButton
    moveCheck = true;   
    screenMode = viewHomepage;
  }

  if (mousePressed && mouseX>(x_position+480) && mouseX<(x_position+515) && mouseY>(y_position+275) && mouseY<(y_position+338)) { //////////selection of a Pub (the Shark one)
    screenMode = viewEvent;
  }
}

public void drawEvent() {
  image (menuMap,x_position, y_position);
  image (back, 0,0);
  image (Pub_event, x_position+500, y_position+260);

  for (int i = 0; i<Pub.length; i++) {
    Pub[i].paint();
  }
  image (Pub_SharkOn,x_position+413,y_position+190);
  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311) {
    moveCheck = true;   
    screenMode = viewHomepage;
  }
}
///////////////////////////////////////menuREADINGS
public void drawReadings() {
  background(0);
  image (menuReadings,0,0);
  image (back, 0, 0);
  image (Add, 380, 10);
  // fill (30,45,100, 30);
  //rect (400,85, 60,35);

  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311) {
    moveCheck = true;   
    screenMode = viewHomepage;
  }

  if (0 < counter && counter < (numberOfLetters+1)) {
    image (keyboard,0,160,480,160);
  }
}


/////////////////////////////////////menuINVITE
public void drawInvite() {
  image (menuInvite,0,0);
  image (back, 0, 0);
  if (mouseX > bx-bl && mouseX < bx+bl && mouseY > by-bh && mouseY < by+bh) {// Test if the cursor is over the box 
    bover = true;
  } 
  else {
    bover = false;
  }
  //imageMode(CENTER);
  image (pizzino, bx,by,bl,bh);

  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311) {
    moveCheck = true;  
    screenMode = viewHomepage;
  }
}
///////////////////////////////////////menuEXIT
public void drawExit() {
  background (0);
  if (mousePressed && mouseX>430 && mouseX<470 && mouseY>260 & mouseY<311) {
    moveCheck = true;  
    screenMode = viewHomepage;
  }
}



















  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "PintofWords_Navigation" });
  }
}
